



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java并发编程之ConcurrentHashMap</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java并发编程之ConcurrentHashMap</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 14:29:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文地址：<a href="http://www.iteye.com/topic/1103980" rel="external nofollow noreferrer">http://www.iteye.com/topic/1103980</a></p>
<p>ConcurrentHashMap 是一个线程安全的Hash Table，它的主要功能是提供了一组和HashTable功能相同但是线程安全的方法。ConcurrentHashMap可以做到读取数据不加锁，并 且其内部的结构可以让其在进行写操作的时候能够将锁的粒度保持地尽量地小，不用对整个ConcurrentHashMap加锁。</p>
<h3>ConcurrentHashMap的内部结构</h3>
<p>ConcurrentHashMap 为了提高本身的并发能力，在内部采用了一个叫做Segment的结构，一个Segment其实就是一个类Hash Table的结构，Segment内部维护了一个链表数组，我们用下面这一幅图来看下ConcurrentHashMap的内部结构：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/675548/201501/061351349062752.png" /></p>
<p>从上面的结构我们可以了解到，ConcurrentHashMap定位一个元素的过程需要进行两次Hash操作，第一次Hash定位到Segment，第 二次Hash定位到元素所在的链表的头部，因此，这一种结构的带来的副作用是Hash的过程要比普通的HashMap要长，但是带来的好处是写操作的时候 可以只对元素所在的Segment进行加锁即可，不会影响到其他的Segment，这样，在最理想的情况下，ConcurrentHashMap可以最高 同时支持Segment数量大小的写操作（刚好这些写操作都非常平均地分布在所有的Segment上），所以，通过这一种结 构，ConcurrentHashMap的并发能力可以大大的提高。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlvj269.html">Arch Linux  LibreOffice 中文输入法不能切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv44ezq.html">计算几何--求凸包模板--Graham算法--poj 1113</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedgpv9.html">网络爬虫系统Heritrix的结构分析 （个人读书报告）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vy759.html">word编辑器解码集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1rm3j9.html">visio2010去除直线交叉处的跨线</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj24749.html">OpenSSH 密钥管理：RSA&sol;DSA 认证&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wv3vlq.html">谈谈分布式事务之三&colon; System&period;Transactions事务详解&lbrack;下篇&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydxm1mq.html">LoC</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjyppk9.html">imageWithContentsOfFile读取全路径返回的image为空的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1637g8.html">CTSC2015&amp;amp&semi;APIO2015滚粗记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1xj328.html">OPNET安装要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05joeq.html">c语言枚举型常量</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdm74d9.html">WdatePicker默认日期为当天</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpddw39.html">PE格式第三讲扩展&comma;VA&comma;RVA&comma;FA&lpar;RAW&rpar;&comma;模块地址的概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkj6pz8.html">Solr搜索引擎搭建详细过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1er6w9.html">Kibana-4&period;6&period;6 marvel插件license过期重新注册</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdo61d9.html">&period;net程序集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy0lpmq.html">vue-学习系列之vue双向绑定原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyznrx9.html">Mac实现远程服务器登录管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1kmyl9.html">Sharing Code Between Silverlight and WPF</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4y05l0q.html">Win7下VS2010使用STLPort 和boost1&period;56&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z3xjz9.html">原生拖拽&comma;拖放事件&lpar;drag and drop&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oew3v9.html">centos6&period;7下 编译安装MySQL5&period;7</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ozxk8.html">linux清理僵尸进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2gvl8.html">Python入门-----介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w44y3q.html">Java添加自定义注解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1op3k8.html">这样就算会了PHP么？-7</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mrkpeq.html">Hunt the Wumpus第二个版本---多怪兽，多洞穴，洞穴间双向互通</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjr0xz9.html">深入理解7816（2）---关于ATR</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k17yr59.html">Window Ghosting（仍可拖动失去响应的窗口，因为我们真正的窗口已经让系统用Ghosting窗口替代了。使用IsHungAppWindow 探测）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
